/*-Dependencies
	MMClientDetector
	VwTouchArea
*/

function VwSwipeNavigator(_viewer, _content, _minX, _minY, _maxX, _maxY){
	/*
if(_viewer != "null"){
		this.touchArea = new VwTouchArea(_viewer);
		this.touchArea.timeout = 500;
		this.touchArea.addListener(this);
	}
*/
	this.content = _content;
	this.minX = _minX;
	this.maxX = _maxX;
	this.minY = _minY;
	this.maxY = _maxY;
	this.positionOnXAxis = 0;
	this.positionOnYAxis = 0;
	this.xStops = [];
	this.yStops = [];
	this.xStopIndex = 0;
	this.yStopIndex = 0;
	this.currentTouchTime = 0;
	this.currentXTouchOffset = 0;
	this.lastYTouchOffset = 0;
	this.lastTouchTime = 0;
	this.lastXTouchOffset = 0;
	this.lastYTouchOffset = 0;
	this.startPositionOnXAxis = 0;
	this.startPositionOnYAxis = 0;
	this.savedPositionsOnXAxis = [];
	this.savedPositionsOnYAxis = [];
	this.startTouchTime = 0;
	this.savePositionInt = 0;
	this.xSpeed = 0;
	this.ySpeed = 0;
	this.xTween = null;
	this.yTween = null;
	this.rightButton = null;
	this.leftButton = null;
	this.upButton = null;
	this.downButton = null;
	this._listeners = [];
	this.addListener(this);
	this.endTransition = "snap";
	var _self = this;
	this.iemousedown = null;
	this.iemousemove = null;
	this.iemouseup = null;
}
VwSwipeNavigator.prototype.touchStart = function( e ) {
	this.lastTouchTime = 0;
	this.lastTouchOffset = 1;
	if(!isNaN(getCurrentStyle(this.content, "left"))){this.positionOnXAxis = getCurrentStyle(this.content, "left");}
	if(!isNaN(getCurrentStyle(this.content, "top"))){this.positionOnYAxis = getCurrentStyle(this.content, "top");}
	this.startPositionOnXAxis = this.positionOnXAxis;
	this.savedPositionsOnXAxis = [];
	this.startPositionOnYAxis = this.positionOnYAxis;
	this.savedPositionsOnYAxis = [];
	this.savePosition();
	
	this.lastXTouchOffset = this.currentXTouchOffset = this.totalXTouchOffset = 0;
	this.lastYTouchOffset = this.currentYTouchOffset = this.totalYTouchOffset = 0;
	this.broadcastMessage('onNavigationStart',{target:this,type:'onNavigationStart'});
	this.startTouchTime = e.time;
	this.clearTween(this.xTween);
	this.clearTween(this.yTween);
	this.content.offsetHeight;
	var _self = this;
	clearInterval(this.savePositionInt);
	this.savePositionInt = window.setInterval(function(){_self.savePosition();}, 1);
};
VwSwipeNavigator.prototype.touchMove = function( e ) {	
	this.positionOnXAxis = this.getComponent(this.minX, this.maxX, parseInt(this.positionOnXAxis + e.xOffset));
	this.positionOnYAxis = this.getComponent(this.minY, this.maxY, parseInt(this.positionOnYAxis + e.yOffset)); 
	this.lastXTouchOffset = this.currentXTouchOffset;
	this.lastYTouchOffset = this.currentYTouchOffset;
	this.currentXTouchOffset = e.xOffset;
	this.currentYTouchOffset = e.yOffset;
	this.currentTouchTime = e.time;
	this.lastTouchTime = this.currentTouchTime;
	this.xSpeed = (this.positionOnXAxis - this.savedPositionsOnXAxis[this.savedPositionsOnXAxis.length - 1])/((this.currentTouchTime - this.startTouchTime)/1000);
	this.ySpeed = (this.positionOnYAxis - this.savedPositionsOnYAxis[this.savedPositionsOnYAxis.length - 1])/((this.currentTouchTime - this.startTouchTime)/1000);
	this.broadcastMessage('onNavigationMove',{target:this,type:'onNavigationMove', speed:this.xSpeed, axis:"x"});
	this.broadcastMessage('onNavigationMove',{target:this,type:'onNavigationMove', speed:this.xSpeed, axis:"y"});
	this.content.style.left = this.positionOnXAxis + "px";
	this.content.style.top = this.positionOnYAxis + "px";
	if(clientDetector.isWebkit()){this.content.style.webkitTransform = 'scale(1)';}
};
VwSwipeNavigator.prototype.savePosition = function(){
	this.savedPositionsOnXAxis.unshift(this.positionOnXAxis);
	if(this.savedPositionsOnXAxis.length > 10){
		this.savedPositionsOnXAxis = this.savedPositionsOnXAxis.slice(0,10);
	}
	this.savedPositionsOnYAxis.unshift(this.positionOnYAxis);
	if(this.savedPositionsOnYAxis.length > 10){
		this.savedPositionsOnYAxis = this.savedPositionsOnYAxis.slice(0,10);
	}
};


VwSwipeNavigator.prototype.touchEnd = function( e ) {
	clearInterval(this.savePositionInt);
	this.xSpeed = (this.positionOnXAxis - this.savedPositionsOnXAxis[this.savedPositionsOnXAxis.length - 1])/((this.currentTouchTime - this.startTouchTime)/1000);
	this.ySpeed = (this.positionOnYAxis - this.savedPositionsOnYAxis[this.savedPositionsOnYAxis.length - 1])/((this.currentTouchTime - this.startTouchTime)/1000);
	switch(this.endTransition){
		case "snap":
		this.gotoNearestStop(this.positionOnXAxis, this.positionOnYAxis);
		break;
		case "easeOut":
		this.easeOut();
		break;
		default:
		this.completeNavigation("x", this.xStops.indexOf(this.positionOnXAxis), this.xStops.length);
		this.completeNavigation("y", this.yStops.indexOf(this.positionOnYAxis), this.yStops.length);
		break;
	}
};

VwSwipeNavigator.prototype.addStopFromElement = function( _elem ) {
	var _x = (_elem.style.left)?parseInt(_elem.style.left)*-1:0;
	var _y = (_elem.style.top)?parseInt(_elem.style.top)*-1:0;
	this.addStop(_x, _y);
};

VwSwipeNavigator.prototype.addStop = function( _x, _y, _id ) {
	var _stopX = this.getComponent(this.minX, this.maxX, _x);
	var _stopY = this.getComponent(this.minY, this.maxY, _y);
	if(this.xStops.indexOf(_stopX) == -1){this.xStops.push(_stopX);this.xStops.sort(function(a,b){return a- b;});}
	if(this.yStops.indexOf(_stopY) == -1){this.yStops.push(_stopY);this.yStops.sort(function(a,b){return a- b;});}
	this.xStopIndex = this.xStops.length-1;
	this.yStopIndex = this.yStops.length-1;
};
VwSwipeNavigator.prototype.removeStop = function( _x, _y, _id ) {
	var _stopX = this.getComponent(this.minX, this.maxX, _x);
	var _stopY = this.getComponent(this.minY, this.maxY, _y);
	if(this.xStops.indexOf(_stopX) != -1){this.xStops.splice(this.xStops.indexOf(_stopX),1);}
	if(this.yStops.indexOf(_stopY) != -1){this.yStops.splice(this.xStops.indexOf(_stopY),1);}
};
	
VwSwipeNavigator.prototype.clearStops = function() {
	this.xStops = [];
	this.yStops = [];
};

VwSwipeNavigator.prototype.handleEvent = function (event, self){
	if (!event) event = window.event;
	if(!self) self = this;
	switch(event.type)
	{
		case "touchstart" :
			event.stopPropagation();
			break;
		case "touchend" :
			self.navigateFromCurrentStop(_distance, _axis);
			break;
		case "mousedown" :
			event.stopPropagation();
			break;
		case "mouseup" :
			self.navigateFromCurrentStop(_distance, _axis);
			break;
	}
};
VwSwipeNavigator.prototype.navigateFromCurrentStop = function(_distance, _axis){
	this.clearTween(this.xTween);
	this.clearTween(this.yTween);
	if(!_axis){_axis = "x";}
	var _arr = (_axis == "y")?this.yStops:this.xStops;
	var _position = (_axis == "y")?this.positionOnYAxis:this.positionOnXAxis;
	var _currentIndex = _arr.indexOf(_position);
	var _newIndex = _currentIndex +_distance;
	var _destination = _position;
	if(_newIndex >= 0 && _newIndex < _arr.length){
		_destination = _arr[_newIndex];
		this.navigateToPosition(_destination, _axis);
	}
};
VwSwipeNavigator.prototype.navigateToStop = function(_stopIndex, _axis){
	var _arr = (_axis == "y")?this.yStops:this.xStops;
	var _position = (_axis == "y")?this.positionOnYAxis:this.positionOnXAxis;
	var _destination = _arr[_stopIndex];
	this.navigateToPosition(_destination, _axis);
};
VwSwipeNavigator.prototype.navigateToPosition = function(_destination, _axis, _duration, _easetype){

	if(clientDetector.isWebkit()){this.content.style.webkitTransform = 'scale(1)';}
	if(!_duration){_duration = 0.6;}
	if(!_easetype){_easetype = "strongEaseOut";}
	if(_axis == "x"){
		this.clearTween(this.xTween);
		this.xTween = new VwTween(this.content.style, "left", VwTween[_easetype], this.positionOnXAxis, _destination, _duration, "px");
		this.xTween.addListener(this);
		this.xTween.start();
		this.positionOnXAxis = _destination;
	}else{
		this.clearTween(this.yTween);
		this.yTween = new VwTween(this.content.style, "top", VwTween[_easetype], this.positionOnYAxis, _destination, _duration, "px");
		this.yTween.addListener(this);
		this.yTween.start();
		this.positionOnYAxis = _destination;
	}
};
VwSwipeNavigator.prototype.easeOut = function(){
	if(isFinite(this.xSpeed) && !isNaN(this.xSpeed) && this.xSpeed !== 0){
		var _xDuration = 2;
		var _xDestination = 0;
		var _currentSpeed = Math.abs(this.xSpeed);
		var _direction = (this.xSpeed < 0)?-1:1;
		var _divisor = 2;
		for(var _s = 0; _s < 10000; ++_s){
			_xDestination = _xDestination + _currentSpeed*_direction;
			_currentSpeed = _currentSpeed/4;
			_divisor += 1;
			if(_currentSpeed < 1){
				break;
			}
		}
		_xDestination = (Math.abs(_xDestination) > 400)?400*_direction:_xDestination;
		_xDestination = this.positionOnXAxis + _xDestination;
		_xDestination = this.getComponent(this.minX, this.maxX, _xDestination);
		this.navigateToPosition(_xDestination, "x", _xDuration, "strongEaseOut");
	}else{
		this.completeNavigation("x", this.xStops.indexOf(this.positionOnXAxis), this.xStops.length);
	}
	if(isFinite(this.ySpeed) && !isNaN(this.ySpeed) && this.ySpeed !== 0){
		var _yDuration = 2;
		var _yDestination = 0;
		var _currentYSpeed = Math.abs(this.ySpeed);
		var _yDirection = (this.ySpeed < 0)?-1:1;
		for(var _sY = 0; _sY < 10000; ++_sY){
			_yDestination = _yDestination + _currentYSpeed*_yDirection;
			_currentYSpeed = _currentYSpeed/4;
			if(_currentYSpeed < 1){
				break;
			}
		}
		_yDestination = (Math.abs(_yDestination) > 400)?400*_yDirection:_yDestination;
		_yDestination = this.positionOnYAxis + _yDestination;
		_yDestination = this.getComponent(this.minY, this.maxY, _yDestination);
		this.navigateToPosition(_yDestination, "y", _yDuration, "strongEaseOut");
	}else{
		this.completeNavigation("y", this.yStops.indexOf(this.positionOnYAxis), this.yStops.length);
	}
};
VwSwipeNavigator.prototype.gotoNearestStop = function(_x, _y) {
	var _yspeed = this.lastYTouchOffset/this.lastTouchTime;
	var _destinationXStop = this.getDestinationStop(_x, this.xStops, this.xSpeed);
	var _destinationYStop = this.getDestinationStop(_y, this.yStops, this.ySpeed);
	var _xDistance = Math.abs(_destinationXStop - this.positionOnXAxis);
	var _xDuration =(_xDistance*this.lastTouchTime)/Math.abs(this.lastXTouchOffset)/1000;
	var _yDistance = Math.abs(_destinationYStop - this.positionOnYAxis);
	var _yDuration =(_yDistance*this.lastTouchTime)/Math.abs(this.lastYTouchOffset)/1000;
	_xDuration = this.getComponent(0.3, 1.5, _xDuration);
	_yDuration = this.getComponent(0.3, 1.5, _yDuration);
	var _self = this;
	var _targetX = this.positionOnXAxis;
	var _targetY = this.positionOnYAxis;
	if(_destinationXStop !== null && _destinationXStop != this.positionOnXAxis){
		_targetX = _destinationXStop;
		this.navigateToPosition(_destinationXStop, "x");
	}else{
		this.completeNavigation("x", this.xStops.indexOf(this.positionOnXAxis), this.xStops.length);
	}
	if(_destinationYStop !== null && _destinationYStop != this.positionOnYAxis){
		_targetY = _destinationYStop;
		this.navigateToPosition(_destinationYStop, "y");
	}else{
		this.completeNavigation("y", this.yStops.indexOf(this.positionOnYAxis), this.yStops.length);
	}
	this.completeSwipe("x", this.xStops.indexOf(_targetX), this.xStops.length);
	this.completeSwipe("y", this.yStops.indexOf(_targetY), this.yStops.length);
};
VwSwipeNavigator.prototype.getDestinationStop = function(_pos, _arr, _speed) {
	var _stops = {previous:null, next:null};
	var _destination = null;
	if(_pos > _arr[_arr.length-1]){ _destination = _arr[_arr.length-1];}
	if(_pos < _arr[0]){ _destination = _arr[0];}
	if(_arr.indexOf[_pos] >= 0){_destination = _pos;}
	if(_destination === null){
		for(var _stop = 0; _stop < _arr.length; _stop++){
			if(_pos > _arr[_stop]){
				_stops.previous = _arr[_stop];
				if((_stop+1) < _arr.length){
					_stops.next = _arr[_stop +1];
				}
			}
		}
		var _closestStop = _stops.previous;
		if(_stops.next !== null){
			_closestStop = ((_pos-_stops.previous) <= (_stops.next - _pos))?_stops.previous:_stops.next;
		}
		if(Math.abs(_pos - _closestStop)<10){
			_destination = _closestStop;
		}else if(_speed > 0.2 && _stops.next !== null){
			_destination = _stops.next;
		}else if(_speed < -0.2){
			_destination = _stops.previous;
		}else{
			_destination = _closestStop;
		}
	}
	return _destination;
};
VwSwipeNavigator.prototype.onMotionFinished = function( e ) {
	var _axis;
	var _index;
	var _length;
	var _self = this;
	if( e.target == this.xTween) {
		_axis = "x";
		_index = this.xStops.indexOf(this.positionOnXAxis);
		_length = this.xStops.length;
	}else{
		_axis = "y";
		_index = this.yStops.indexOf(this.positionOnYAxis);
		_length = this.yStops.length;
	}
	if(clientDetector.isWebkit()){
		this.content.style.webkitTransform = 'scale(1)';
		this.content.offsetHeight;
		this.content.style.webkitTransform = 'none';
	}
	this.completeNavigation(_axis, _index, _length);
};
VwSwipeNavigator.prototype.onMotionChanged = function( e ) {
	if(e.target == this.xTween){
		this.positionOnXAxis = e.target._pos;
		this.broadcastMessage('onNavigationMove',{target:this,type:'onNavigationMove', speed:this.xSpeed, axis:"x"});
	}
	if(e.target == this.yTween){
		this.positionOnYAxis = e.target._pos;
		this.broadcastMessage('onNavigationMove',{target:this,type:'onNavigationMove', speed:this.ySpeed, axis:"y"});
	}
};
VwSwipeNavigator.prototype.clearTween = function( _twn ) {
	if(_twn != null){
		_twn.stop();
	}
};
VwSwipeNavigator.prototype.completeNavigation = function( _axis, _index, _length ) {
	this[_axis + "StopIndex"] = _index;
	this.broadcastMessage('onNavigationComplete',{target:this,type:'onNavigationComplete', axis:_axis, index:_index, length:_length});
};

VwSwipeNavigator.prototype.completeSwipe = function(_axis, _index, _length){
	this.broadcastMessage('onSwipeComplete',{target:this,type:'onSwipeComplete', axis:_axis, index:_index, length:_length});
};

VwSwipeNavigator.prototype.addListener = function(o){
	this.removeListener (o);
	return this._listeners.push(o);
};

VwSwipeNavigator.prototype.removeListener = function(o){
	var a = this._listeners;
	var i = a.length;
	while (i--) {
		if (a[i] == o) {
			a.splice (i, 1);
			return true;
		}
	}
	return false;
};

VwSwipeNavigator.prototype.broadcastMessage = function(){
	var arr = [];
	for(var i = 0; i < arguments.length; i++){
		arr.push(arguments[i]);
	}
	var e = arr.shift();
	var a = this._listeners;
	var l = a.length;
	for (var i=0; i<l; i++){
		if(a[i][e])
		a[i][e].apply(a[i], arr);
	}
};

VwSwipeNavigator.prototype.getComponent = function(low, high, target){
	if (low > target){
			return low;
		}else if (target > high){
			return high;
		}else{
			return target;
		}
		return 0;
}
VwSwipeNavigator.prototype.getDifference = function( a, b ) {
	if( a > b){
		return a-b;
	}else{
		return b-a;
	}
};
